import(Module_System)
import(Module_Players)
import(Module_Defines)
import(Module_PopScript)
import(Module_Game)
import(Module_Objects)
import(Module_Map)
import(Module_Person)
include("UtilPThings.lua")
include("UtilRefs.lua")
include("LibBuildings.lua")
include("LibSpells.lua")

local ReincPos = {
  MAP_XZ_2_WORLD_XYZ(44, 202),
  MAP_XZ_2_WORLD_XYZ(60, 40),
  MAP_XZ_2_WORLD_XYZ(160, 178)
}

allied = {}
blueShamanOwner = 0
yellowShamanOwner = 0
redShamanOwner = 0

for i,k in ipairs(ReincPos) do
  local me = world_coord3d_to_map_ptr(k)
  me.MapWhoList:processList(function(t)
    if (t.Type == T_PERSON) then
      if (t.Model == M_PERSON_MEDICINE_MAN) then
        if (i == 1) then
          blueShamanOwner = t.Owner
          table.insert(allied, t.Owner)
        end
        if (i == 2) then
          yellowShamanOwner = t.Owner
          table.insert(allied, t.Owner)
        end
        if (i == 3) then
          redShamanOwner = t.Owner
        end
      end
    end
    return true
  end)
end

for i, v in ipairs(allied) do
    for k, t in ipairs(allied) do
        set_players_allied(v, t)
    end
end

function OnTurn()
  --If blue is dead, kill Yellow
  if (_gsi.Players[blueShamanOwner].NumPeople == 0) then
    ProcessGlobalTypeList(T_BUILDING, function(t)
          if (t.Owner == yellowShamanOwner) then
            createThing(T_EFFECT, M_EFFECT_LIGHTNING_BOLT, TRIBE_NEUTRAL, t.Pos.D3, false, false)
          end
      return true
      end)
      ProcessGlobalTypeList(T_PERSON, function(t)
        if (t.Owner == yellowShamanOwner) then
          damage_person(t, redShamanOwner, 90000, 1)
        end
      return true
      end)
  end

  --If yellow is dead, kill Blue
  if (_gsi.Players[yellowShamanOwner].NumPeople == 0) then
    ProcessGlobalTypeList(T_BUILDING, function(t)
          if (t.Owner == blueShamanOwner) then
            createThing(T_EFFECT, M_EFFECT_LIGHTNING_BOLT, TRIBE_NEUTRAL, t.Pos.D3, false, false)
          end
      return true
      end)
      ProcessGlobalTypeList(T_PERSON, function(t)
        if (t.Owner == blueShamanOwner) then
          damage_person(t, redShamanOwner, 90000, 1)
        end
      return true
      end)
  end
end