import(Module_System)
import(Module_Players)
import(Module_Defines)
import(Module_PopScript)
import(Module_Game)
import(Module_Objects)
import(Module_Map)
import(Module_Person)
include("UtilPThings.lua")
include("UtilRefs.lua")
include("LibBuildings.lua")
include("LibSpells.lua")

local ReincPos = {
  MAP_XZ_2_WORLD_XYZ(184, 228)
}

blueShamanOwner = 0

for i,k in ipairs(ReincPos) do
  local me = world_coord3d_to_map_ptr(k)
  me.MapWhoList:processList(function(t)
    if (t.Type == T_PERSON) then
      if (t.Model == M_PERSON_MEDICINE_MAN) then
        SetOneShotCharges(t.Owner, M_SPELL_FIRESTORM, 2)
        SetOneShotCharges(t.Owner, M_SPELL_SWAMP, 3)
        SetOneShotCharges(t.Owner, M_SPELL_WHIRLWIND, 3)
        SetOneShotCharges(t.Owner, M_SPELL_HYPNOTISM, 3)
        SetOneShotCharges(t.Owner, M_SPELL_LIGHTNING_BOLT, 4)
        SetOneShotCharges(t.Owner, M_SPELL_INSECT_PLAGUE, 4)
        blueShamanOwner = t.Owner
      end
    end
    return true
  end)
end

function OnTurn()
  if (GetTurn() == 24) then
    _gsi.Players[blueShamanOwner].Flags = _gsi.Players[blueShamanOwner].Flags  | (1<<16)
    _gsi.Players[blueShamanOwner].Flags = _gsi.Players[blueShamanOwner].Flags  | (1<<19)
  end
end